﻿using System;


namespace StaticClassIsolators
{
    public class DatemTimeIsolator : IDisposable
    {
        private static DateTime changedNowDateTime;
        private static bool nowChanged;
        
        public static DateTime Now
        {
            get { return nowChanged ? changedNowDateTime : DateTime.Now; }
        }
        
        public static IDisposable NowIs(DateTime dateTime)
        {
            changedNowDateTime = dateTime;
            nowChanged = true;
            return new DatemTimeIsolator();
        }
        
        public void Dispose()
        {
            nowChanged = false;
        }
    }
}
