﻿using System;
using System.IO;


namespace StaticClassIsolators
{
    public class DirectoryIsolator : IDisposable
    {
        enum ExistsAction
        {
            PassTrought,
            ReturnValue,
            Function
        }

        private static bool existsReturnValue;
        private static Func<string, bool> existsReturnFuction;
        private static ExistsAction existsaction = ExistsAction.PassTrought;

        public static bool Exists(string path)
        {
            switch (existsaction)
            {
                case ExistsAction.ReturnValue:
                    return existsReturnValue;
                case ExistsAction.Function:
                    return existsReturnFuction(path);
            }

            return Directory.Exists(path);
        }

        public static IDisposable ExistsIs(bool value)
        {
            existsReturnValue = value;
            existsaction = ExistsAction.ReturnValue;
            return new DirectoryIsolator();
        }

        public static IDisposable ExistsIs(Func<string, bool> function)
        {
            existsaction = ExistsAction.Function;
            existsReturnFuction = function;
            return new DirectoryIsolator();
        }
        
        public void Dispose()
        {
            existsaction = ExistsAction.PassTrought;
        }
    }
}
