﻿using StaticClassIsolators;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;

namespace StaticClassIsolatorsTest
{
    
    
    /// <summary>
    ///This is a test class for Class1Test and is intended
    ///to contain all Class1Test Unit Tests
    ///</summary>
    [TestClass()]
    public class Class1Test
    {


        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion


        /// <summary>
        ///A test for IsIt2012
        ///</summary>
        [TestMethod()]
        public void Class_IsIt2012_Is2012()
        {
            using (DatemTimeIsolator.NowIs(new DateTime(2012, 12, 30)))
            {
                Class1 target = new Class1();
                bool actual;
                actual = target.IsIt2012;
                Assert.AreEqual(true, actual);
            }
        }

        /// <summary>
        ///A test for IsIt2012
        ///</summary>
        [TestMethod()]
        public void Class1_IsIt2012_Not2012()
        {
            using (DatemTimeIsolator.NowIs(new DateTime(2011, 12, 30)))
            {
                Class1 target = new Class1();
                bool actual;
                actual = target.IsIt2012;
                Assert.AreEqual(false, actual);
            }
        }

        /// <summary>
        ///A test for ProcessFiles
        ///</summary>
        [TestMethod()]
        [ExpectedException(typeof(ArgumentException))]
        public void Class1_ProcessFiles_SettingReturnValueFalse()
        {
            using (DirectoryIsolator.ExistsIs(false))
            {
                Class1 target = new Class1();
                string path = @"C:\windows";
                target.ProcessFiles(path);
            }
        }

        /// <summary>
        ///A test for ProcessFiles
        ///</summary>
        [TestMethod()]
        [ExpectedException(typeof(ArgumentException))]
        public void Class1_ProcessFiles_SettingDelegateToReturnFalse()
        {
            using (DirectoryIsolator.ExistsIs(delegate(string s)
            { return false; }))
            {
                Class1 target = new Class1();
                string path = @"C:\windows";
                target.ProcessFiles(path);
            }
        }
    }
}
